﻿var HourWheelId;
var MinuteWheelId;
var HourWheelCall;
var MinuteWheelCall;
var HourWheelChange;
var MinuteWheelChange;
var me;

//@ sourceURL=wisej.web.Widget.startup.js
/**
 * Initializes the widget.
 *
 * This function is called when the InitScript property of
 * wisej.web.Widget changes.
 *
 * 'this' refers to the container which is a wisej.web.Widget instance.
 *
 * 'this.container' refers to the DOM element and can be used to initialize
 * the third party javascript widget.
 *
 * @param options {Map} Options map (optional).
 */
this.init = function (options) {
    var options = $options;
    var hourValue = options.hourValue;
    var minuteValue = options.minuteValue;

    HourWheelId = this.getId() + "_hour-wheel";
    MinuteWheelId = this.getId() + "_minute-wheel";

    this.container.innerHTML = "<div class='wrapper'><div id='" + HourWheelId + "' style='width: 70px'></div><div id='" + MinuteWheelId + "' style='width: 70px'></div></div>";
    me = this;

    HourWheelCall = new this.Wheel(document.getElementById(HourWheelId), {
        initIdx: hourValue,
        loop: true,
        length: 24,
        width: 23,
    });

    MinuteWheelCall = new this.Wheel(document.getElementById(MinuteWheelId), {
        initIdx: minuteValue,
        loop: true,
        length: 60,
        width: 23,
        perspective: "left",
    });
}

/**
 * Updates the widget when the options object changes.
 *
 * @param options {Map} Options map (optional).
 * @param old {Map} Previous options map (optional).
 */
/*this.update = function (options, old) {
    // your update code.
}*/

/**
 * Keen Slider TimePicki
 * 
 * 
 */
this.Wheel = function (wrapper, options) {
    var defaultOptions = {
        initIdx: 0,
        loop: false,
        perspective: "center",
        width: 100,
        label: "",
    }

    options = { ...defaultOptions, ...options }

    var wheel
    var slides = []

    var slidesPerView = options.loop ? 9 : 1
    var slideDegree = 360 / 20
    var wheelSize = 20
    var radius = 200 / 2

    function createMarkup() {
        for (var i = 0; i < options.length; i++) {
            var div = document.createElement("div");
            div.setAttribute("class", "wheel__slide");
            slides.push(div);
        };

        wheel = createDiv(
            "wheel keen-slider wheel--perspective-" + options.perspective,
            [
                createDiv("wheel__shadow-top"),
                createDiv("wheel__inner", [
                    createDiv("wheel__slides", slides, "width:" + options.width + "px"),
                    createDiv("wheel__label", document.createTextNode(options.label)),
                ]),
                createDiv("wheel__shadow-bottom"),
            ]
        );
        wrapper.appendChild(wheel);
    }

    function init() {
        createMarkup();
        var sliderOptions = {
            centered: options.loop,
            vertical: true,
            friction: 0.0025,
            initial: options.initIdx || 0,
            loop: options.loop,
            dragSpeed: (val, instance) => {
                var height = instance.details().widthOrHeight
                return (
                    val *
                    (height /
                        ((height / 2) * Math.tan(slideDegree * (Math.PI / 180))) /
                        slidesPerView)
                )
            },
            move: (s) => {
                updateSlides(options, slides, slidesPerView, wheelSize, radius, s.details());
            },
            slideChanged: (s) => {
                if (s.details().size == 24) {
                    hourValue = s.details().relativeSlide
                    HourWheelChange = s.details();
                }
                if (s.details().size == 60) {
                    minuteValue = s.details().relativeSlide
                    MinuteWheelChange = s.details();
                }
            },
            /*beforeChange: () => {

            },*/
            /*afterChange: () => {

            },*/
            rubberband: !options.loop,
            mode: "free-snap",
            slides: options.length,
            slidesPerView: slidesPerView,
        }
        var slider = new KeenSlider(wheel, sliderOptions);
        return slider;
    }

    return init()
}

function createDiv(className, append, style) {
    var div = document.createElement("div");
    if (className) div.setAttribute("class", className);
    if (style) div.setAttribute("style", style);
    if (!append) return div;
    if (!Array.isArray(append)) append = [append];
    append.forEach((element) => {
        div.appendChild(element)
    })
    return div;
}

function updateSlides(options,slides,slidesPerView,wheelSize, radius, details) {
    var offset = options.loop ? 1 / 2 - 1 / slidesPerView / 2 : 0;
    var values = [];
    for (let i = 0; i < options.length; i++) {
        var distance = (details.positions[i].distance - offset) * slidesPerView;

        var rotate =
            Math.abs(distance) > wheelSize / 2
                ? 180
                : distance * (360 / wheelSize) * -1;
        var style = {
            transform: `rotateX(${rotate}deg) translateZ(${radius}px)`,
            WebkitTransform: `rotateX(${rotate}deg) translateZ(${radius}px)`,
        };
        var value = options.setValue
            ? options.setValue(i, details.absoluteSlide + Math.round(distance))
            : i;
        values.push({ style, value });
        slides[i].style.transform = style.transform;
        slides[i].innerHTML = value;
    }
}
