﻿
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Runtime.CompilerServices;
using System.Threading.Tasks;
using Wisej.Core;
using Wisej.Design;
using Wisej.Web;

namespace Wisej.Web.Ext.KeenSlider
{
    [ToolboxBitmap(typeof(TimePicker))]
    [DefaultEvent("ValueChanged")]
    public partial class TimePicker : Wisej.Web.Widget
    {
        /// <summary> 
        /// Required designer variable.
        /// </summary>
        private System.ComponentModel.IContainer components = null;
        public TimePicker()
        {
            InitializeComponent();
            DateTime wDateTime = DateTime.Now;

            this.HourValue = wDateTime.Hour;
            this.MinuteValue = wDateTime.Minute;
        }

        /// <summary> 
        /// Clean up any resources being used.
        /// </summary>
        /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
        protected override void Dispose(bool disposing)
        {
            if (disposing && (components != null))
            {
                components.Dispose();
            }
            base.Dispose(disposing);
        }

        #region Wisej Designer generated code

        /// <summary> 
        /// Required method for Designer support - do not modify 
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            this.SuspendLayout();
            // 
            // KeenSlider
            // 
            this.BackColor = System.Drawing.Color.Black;
            this.MaximumSize = new System.Drawing.Size(357, 298);
            this.MinimumSize = new System.Drawing.Size(357, 298);
            this.Name = "TimePicker";
            this.Size = new System.Drawing.Size(357, 298);
            this.Text = "TimePicker";
            this.ResumeLayout(false);

        }
        #endregion

        /// <summary>
        /// Overridden to create our initialization script.
        /// </summary>
        [Browsable(false)]
        [DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public override string InitScript
        {
            get { return BuildInitScript(); }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
		[MethodImpl(MethodImplOptions.NoInlining)]
        private string BuildInitScript()
        {
            dynamic options = new DynamicObject();
            options.hourValue = this.HourValue;
            options.minuteValue = this.MinuteValue;

            string script = string.Empty;
            script = GetResourceString("Wisej.Web.Ext.KeenSlider.JavaScript.InitScript.js");
            script = script.Replace("$options", options.ToString());
            return script;
        }

        /// <summary>
        /// Overridden to return our list of script resources.
        /// </summary>
        [Browsable(false)]
        [DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public override List<Package> Packages
        {
            get
            {
                if (base.Packages.Count == 0)
                {
                    // initialize the loader with the required libraries.
                    base.Packages.Add(new Package()
                    {
                        Name = "keen-slider.min.css",
                        Source = GetResourceURL("Wisej.Web.Ext.KeenSlider.KeenSlider.Css.keen-slider.min.css")
                    });

                    base.Packages.Add(new Package()
                    {
                        Name = "styles.css",
                        Source = GetResourceURL("Wisej.Web.Ext.KeenSlider.KeenSlider.Css.styles.css")
                    });

                    base.Packages.Add(new Package()
                    {
                        Name = "keen-slider.min.js",
                        Source = GetResourceURL("Wisej.Web.Ext.KeenSlider.KeenSlider.JavsScript.keen-slider.min.js")
                    });
                }
                return base.Packages;
            }
        }

        public int HourValue
        {
            get
            {
                return this._hourvalue;
            }
            set
            {
                if (this._hourvalue != value)
                {
                    this._hourvalue = value;
                    Update();
                }
            }
        }
        private int _hourvalue = 0;

        public int MinuteValue
        {
            get
            {
                return this._minutevalue;
            }
            set
            {
                if (this._minutevalue != value)
                {
                    this._minutevalue = value;
                    Update();
                }
            }
        }
        private int _minutevalue = 0;
    }
}
